/*////////////////////////////////////////////////////////////////////////
Copyright (c) 2006 National Institute of Advanced Industrial Science and Technology (AIST)

Permission to use this material for noncommercial and/or evaluation
purpose, copy this material for your own use, and distribute the copies
via publicly accessible on-line media, without fee, is hereby granted
provided that the above copyright notice and this permission notice
appear in all copies.
AIST MAKES NO REPRESENTATIONS ABOUT THE ACCURACY OR SUITABILITY OF THIS
MATERIAL FOR ANY PURPOSE.  IT IS PROVIDED "AS IS", WITHOUT ANY EXPRESS
OR IMPLIED WARRANTIES.
/////////////////////////////////////////////////////////////////////////
Content-Type:   program/C; charset=US-ASCII
Program:        dgsign.c
Author:         Yutaka Sato <ysato@delegate.org>
Description:

History:
        060924	extracted from dgauth.c
//////////////////////////////////////////////////////////////////////#*/
#include "delegate.h"
#include "file.h"
#include "credhy.h"
#include "auth.h"

char *fgetsE(PVStr(str),int siz,FILE *fp);
int fputsE(PCStr(str),FILE *fp);

#ifndef ADMIN
#define ADMIN	"none@nowhere"
#endif

extern const char *DELEGATE_pubkey;
int DGverify(PCStr(sign)){
	return 0;
}

int md5_main(int ac,char *av[]);
int addMD5fp(MD5 *md5,FILE *fp){
	CStr(buf,8*1024);
	int rcc;
	int siz = 0;

	while( 0 < (rcc = fread(buf,1,sizeof(buf),fp)) ){
		siz += rcc;
		addMD5(md5,buf,rcc);
	}
	return siz;
}
int addMD5file(MD5 *md5,PCStr(fname)){
	FILE *fin;
	CStr(fnameb,1024);

	if( strpbrk(fname,"\r\n") ){
		Xsscanf(fname,"%[^\r\n]",AVStr(fnameb));
		fname = fnameb;
	}
	if( fin = fopen(fname,"r") ){
		addMD5fp(md5,fin);
		fclose(fin);
		return 0;
	}else{
		return -1;
	}
}
int MD5_mainX(int ac,const char *av[],FILE *afls,PVStr(out),FILE *log){
	int ai;
	int fi;
	int fc = 0;
	FILE *fls;
	CStr(fnam,256);
	MD5 *md5;
	CStr(digest,64);

	for( ai = 1; ai < ac; ai++ ){
		if( streq(av[ai],"-c") ){
			fc = 1;
		}else
		if( streq(av[ai],"-f") ){
			if( ai+1 < ac ){
				ai++;
				fc = 1;
			}
		}else
		if( av[ai][0] != '-' ){
		}
	}
	if( afls == 0 && fc == 0 ){
		return md5_main(ac,(char**)av);
	}

	md5 = newMD5();
	if( afls ){
		while( fgets(fnam,sizeof(fnam),afls) ){
			addMD5file(md5,fnam);
		}
	}
	for( ai = 1; ai < ac; ai++ ){
		if( streq(av[ai],"-f") ){
			if( ai+1 < ac ){
				ai++;
				if( streq(av[ai],"-") )
					fls = stdin;
				else	fls = fopen(av[ai],"r");
				if( fls ){
					while( fgets(fnam,sizeof(fnam),fls) ){
						addMD5file(md5,fnam);
					}
					if( fls != stdin )
						fclose(fls);
				}else{
				}
			}
		}else{
			addMD5file(md5,av[ai]);
		}
	}
	endMD5(md5,digest);
	MD5toa(digest,(char*)out);
	return 0;
}
int MD5_main(int ac,const char *av[]){
	int code;
	CStr(md5,64);

	truncVStr(md5);
	code = MD5_mainX(ac,av,NULL,AVStr(md5),stderr);
	if( md5[0] ){
		printf("%s\n",md5);
	}
	return code;
}
int cafe_mainX(int ac,const char *av[],FILE *out,FILE *log);
void sort_file(FILE *src,FILE *dst,int rev);
const char *DELEGATE_srcsign();
int srcmd5_main(int ac,const char *av[]){
	int ai;
	const char *nav[1024];
	int nac;
	FILE *tmp;
	FILE *tmp2;
	CStr(md5,128);
	int csrc = 0;
	const char *ofile = 0;
	FILE *ofp = stdout;

	nac = 0;
	nav[nac++] = "-Ffind";
	for( ai = 1; ai < ac && ai < elnumof(nav)-2; ai++ ){
		if( strncmp(av[ai],"-csrc",5) == 0 ){
			csrc = 1;
			continue;
		}
		if( streq(av[ai],"-o") ){
			if( ai+1 < ac ){
				ofile = av[++ai];
			}
			continue;
		}
		nav[nac++] = av[ai];
	}
	nav[nac++] = "-print";
	nav[nac] = 0;

	tmp = TMPFILE("srcmd5");
	cafe_mainX(nac,nav,tmp,stderr);
	fflush(tmp);
	fseek(tmp,0,0);
	tmp2 = TMPFILE("srcmd5");
	sort_file(tmp,tmp2,0);
	fclose(tmp);

	fflush(tmp2);
	fseek(tmp2,0,0);
	truncVStr(md5);
	MD5_mainX(0,NULL,tmp2,AVStr(md5),stderr);
	fclose(tmp2);

	if( csrc ){
		CStr(sdate,128);
		CStr(sign,512);
		const char *ver = DELEGATE_ver();
		const char *fname = "BUILT_SRCSIGN";
		if( ofile ){
			FILE *fp;
			if( fp = fopen(ofile,"w") )
				ofp = fp;
		}
		StrftimeLocal(AVStr(sdate),sizeof(sdate),"%Y%m%d%H%M%S%z",
			time(0),0);
		fprintf(stderr,"source MD5 = %s\n",md5);
		setVStrEnd(md5,16);
		sprintf(sign,"{%s=%s:%s:%s:%s:-}","BLDSIGN",ver,sdate,md5,
			ADMIN);
		fprintf(ofp,"#define %s \"\\n\\\n%s\\n\"+%d\n",fname,sign,10);
	}else{
		CStr(smd5,128);
		printf("source MD5 = %s\n",md5);
		Xsscanf(DELEGATE_srcsign(),"%*[^:]:%*[^:]:%[^:]",AVStr(smd5));
		if( strstr(md5,smd5) ){
printf("*** OK, this is the original source from DeleGate.ORG\n");
		}else{
printf("*** BAD, spoofed or forged, not original code by DeleGate.ORG\n");
		}
	}
	return 0;
}
int binmd5_main(int ac,const char *av[]){
	CStr(path,1024);
	CStr(rbuf,1024);
	int rcc;
	FILE *fp;
	MD5 *md5;
	CStr(digest,64);
	CStr(bmd5,64);

	strcpy(path,EXEC_PATH);
	FullpathOfExe(AVStr(path));
	if( fp = fopen(path,"r") ){
		md5 = newMD5();
		while( 0 < (rcc = fread(rbuf,1,sizeof(rbuf),fp)) ){
			addMD5(md5,rbuf,rcc);
		}
		endMD5(md5,digest);
		MD5toa(digest,(char*)bmd5);
		printf("%s\n",bmd5);
		fclose(fp);
	}
	return 0;
}


/*
 * built-in parameters
 * Compiled-By:
 * Approved-By:
 * Signed-By:
 * ADMIN=
 * OWNER= 
 * RELIABLE=
 * DGROOT=
 */
char *mySIG[8] = {(char*)mySIG,(char*)mySIG,(char*)mySIG};
const char mySIGN1[128] = "MySign1:";
char mySIGN2[128] = "MySign2:";
int mysig_main(int ac,const char *av[]){
	CStr(path,1024);
	CStr(amd5,512);
	FILE *fp;
	FILE *xfp;
	int fi,fc,fw;
	int prevfw;
	int sigaddr;

	strcpy(path,EXEC_PATH);
	FullpathOfExe(AVStr(path));

	strtoHex((char*)mySIG,sizeof(mySIG),AVStr(amd5),sizeof(amd5));
	printf("%X %d %d %s %s\n",mySIG,mySIG,sizeof(mySIG),
		amd5,path);

	fp = fopen(path,"r");
	sigaddr = 0;
	prevfw = 0;
	if( fp ){
		for( fi = 0; fread(&fw,1,sizeof(fw),fp) == sizeof(fw); fi += sizeof(fw)){
			if( (void*)fw == (void*)mySIG ){
				fprintf(stderr,"%X %X\n",fi,fw);
				if( prevfw == fw ){
					sigaddr = fi - sizeof(fw);
					break;
				}
			}
			prevfw = fw;
		}
		fprintf(stderr,"size=%d mySIG ADDR=%X\n",fi,sigaddr);
		if( sigaddr ){
			xfp = fopen("dg.sig","w+");
			if( xfp ){
				fseek(fp,0,0);
				for( fi = 0; fi < sigaddr; fi++ ){
					fc = getc(fp);
					putc(fc,xfp);
				}
				for( fi = 0; fi < sizeof(mySIG); fi++ ){
					fc = getc(fp);
					putc(fi,xfp);
				}
				while( (fc = getc(fp)) != EOF )
					putc(fc,xfp);
			}
		}
	}
	return 0;
}

int rsasign_main(int ac,const char *av[]){
	int ok;
	const char *pass;

	return 0;
}

int pubDecyptRSA(PCStr(pubkey),int len,PCStr(enc),PVStr(dec));
static int rsadecode(PCStr(pubkey),PCStr(sig),PVStr(ysig)){
	CStr(xsig,1024);
	int xlen;
	int ylen;

	setVStrEnd(ysig,0);
	xlen = str_from64(sig,strlen(sig),AVStr(xsig),sizeof(xsig));
	ylen = pubDecyptRSA(pubkey,xlen,xsig,AVStr(ysig));
	if( 0 <= ylen ){
		setVStrEnd(ysig,ylen);
	}else{
		setVStrEnd(ysig,0);
	}
	return ylen;
}

static void rsavrfy1(PCStr(pubkey),PCStr(xsig),int xlen){
	CStr(sig,1024);
	CStr(ysig,1024);
	int slen;
	int dlen;

	slen = str_from64(xsig,xlen,AVStr(sig),sizeof(sig));
	dlen = pubDecyptRSA(pubkey,slen,sig,AVStr(ysig));
	if( 0 <= dlen ){
		setVStrEnd(ysig,dlen);
		printf("%s\n",ysig);
	}
}
int rsavrfy_main(int ac,const char *av[]){
	int ai;
	CStr(xsig,1024);
	int xlen;
	const char *pubkey = DELEGATE_pubkey;
	const char *a1;
	FILE *fp;
	int nput = 0;

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		nput++;
		fp = fopen(a1,"r");
		if( fp == NULL ){
			fprintf(stderr,"Cannot open: %s\n",a1);
			break;
		}
		xlen = fread(xsig,1,sizeof(xsig),fp);
		fclose(fp);
		rsavrfy1(pubkey,xsig,xlen);
	}
	if( nput == 0 ){
		xlen = fread(xsig,1,sizeof(xsig),stdin);
		rsavrfy1(pubkey,xsig,xlen);
	}
	return 0;
}

typedef struct {
	int s_flags;
	int s_off;	/* offset in the file of the appearence */
	MStr(s_name,64);
	MStr(s_ver,64);
	MStr(s_date,64);
	MStr(s_md5,64);
	MStr(s_signer,64);
	MStr(s_sign,256);
	MStr(s_signb,1024);
} FileSign;

static int scanFileSign(PCStr(sign),FileSign *fsig){
	int ne;
	ne = Xsscanf(sign,"{%[^=]=%[^:]:%[^:]:%[^:]:%[^:]:%[^:}]",
		AVStr(fsig->s_name),
		AVStr(fsig->s_ver),
		AVStr(fsig->s_date),
		AVStr(fsig->s_md5),
		AVStr(fsig->s_signer),
		AVStr(fsig->s_sign));
	if( ne == 6 ){
		strsubst(AVStr(fsig->s_sign),"`M",""); /* "\r" by fgetsE() */
		fsig->s_flags = 1;
		return 6;
	}
	fsig->s_flags = 0;
	return -1;
}

/*
 * "{NOSIGN: ... }"
 * "{NOSIGN: ...
 * ...
 * }"
 */
static void getsigns(PCStr(iexe),int fovw,int fverb,FILE *ifp,FILE *ofp,FileSign *ssig,FileSign *bsig,FileSign *fsig,MD5 *md5,PVStr(xd)){
	int off;
	CStr(buf,1024);
	refQStr(dp,buf);
	refQStr(ep,buf);
	CStr(digest,32);

	while( 1 ){
		off = ftell(ifp);
		if( fgetsE(AVStr(buf),sizeof(buf),ifp) == NULL ){
			break;
		}
		if( (dp = strstr(buf,"\"{NOSIGN")) && dp[8] == ':' ){
			if( ofp ){
				fputsE(buf,ofp);
			}
			if( ep = strstr(dp,"}\"") ){
				strcpy(dp,ep+2);
			}else{
				truncVStr(dp);
				if( md5 ){ addMD5(md5,buf,strlen(buf)); }
				while( fgetsE(AVStr(buf),sizeof(buf),ifp) ){
					if( ofp ){
						fputsE(buf,ofp);
					}
					if( dp = strstr(buf,"}\"") ){
				if( md5 ){ addMD5(md5,dp+2,strlen(dp+2)); }
						break;
					}
				}
				continue;
			}
		}else
		if( (dp = strstr(buf,"{SRCSIGN")) && dp[8] == '=' ){
			if( ofp ){
				fputsE(buf,ofp);
			}
			if( strchr(buf,'}') == 0 ){
				refQStr(bp,buf);
				int ch;
				bp = buf + strlen(buf);
				while( (ch = getc(ifp)) != EOF ){
					if( ofp ){
						putc(ch,ofp);
					}
					setVStrPtrInc(bp,ch);
					if( ch == '}' ){
						setVStrPtrInc(bp,0);
						break;
					}
				}
			}
			strsubst(AVStr(dp),"\r","");
			strsubst(AVStr(dp),"\n","");
			scanFileSign(dp,ssig);
		}else
		if( (dp = strstr(buf,"{BLDSIGN")) && dp[8] == '=' ){
			if( ofp ){
				fputsE(buf,ofp);
			}
			scanFileSign(dp,bsig);
		}else
		if( (dp = strstr(buf,"{EXESIGN")) && dp[8] == '=' ){
			strcpy(fsig->s_signb,buf);
			if( dp = strchr(fsig->s_signb,'}') )
				((char*)dp)[1] = 0;
			if( ofp != 0 ){
				fsig->s_off = ftell(ofp);
				if( fverb )
					fprintf(stderr,"%s\n",fsig->s_signb);
			}else{
				if( fverb )
					printf("%s\n",fsig->s_signb);
				if( md5 == 0 )
					break;
			}
			if( ofp ){
				fputsE(buf,ofp);
			}
			if( dp = strchr(buf,'}') ){
				strcpy(buf,dp+1);
			}
		}else{
			if( ofp ){
				fputsE(buf,ofp);
			}
		}
		if( md5 ){ addMD5(md5,buf,strlen(buf)); }
	}
	if( ssig->s_flags ){
		CStr(ssign,512);
		CStr(osign,512);

		truncVStr(ssign);
		Xsscanf(ssig->s_sign,"%[0-9A-Za-z+/=]",AVStr(ssign));
		rsadecode(DELEGATE_pubkey,ssign,AVStr(osign));
		if( osign[0] ){
			fprintf(stderr,"-- src Sign> %s\n",osign);
		}else{
			fprintf(stderr,"-- src Sign? %s:%s:%s:%s\n",
				ssig->s_ver,ssig->s_date,ssig->s_md5,
				ssig->s_signer);
		}
	}
	if( bsig->s_name[0] ){
		fprintf(stderr,"-- bld Sign> %s:%s:%s:%s\n",
			bsig->s_ver,bsig->s_date,bsig->s_md5,
			bsig->s_signer);
	}
	if( md5 ){
		endMD5(md5,digest);
		MD5toa(digest,(char*)xd);

		if( 0 <= scanFileSign(fsig->s_signb,fsig) ){
			CStr(ssign,512);
			CStr(osign,512);

			truncVStr(ssign);
			Xsscanf(fsig->s_sign,"%[0-9A-Za-z+/=]",AVStr(ssign));
			rsadecode(DELEGATE_pubkey,ssign,AVStr(osign));
			if( osign[0] ){
				fprintf(stderr,"-- exe Sign> %s\n",osign);
			}else{
				fprintf(stderr,"-- exe Sign? %s:%s:%s:%s\n",
					fsig->s_ver,fsig->s_date,
					fsig->s_md5,fsig->s_signer);
			}
			if( strstr(osign,xd) ){
fprintf(stderr,"** OK, this executable is as released from DeleGate.ORG: %s\n",
iexe);
			}else{
				if( ofp == 0 )
					printf("-- File MD5: %s\n",xd);
				else	fprintf(stderr,"-- File MD5: %s\n",xd);
if( !fovw )
fprintf(stderr,"** BAD, possibly spoofed or forged binary: %s\n",iexe);
			}
		}else{
			printf("-- File MD5: %s\n",xd);
		}
	}
}

int exesign_main(int ac,const char *av[]){
	int ai;
	const char *a1;
	const char *iexe = 0;
	const char *oexe = 0;
	int fovw = 0;
	int fverb = 0;
	CStr(mypath,1024);
	CStr(buf,1024);
	refQStr(dp,buf);
	FILE *ifp = stdin;
	FILE *ofp = 0;
	MD5 *md5 = 0;
	CStr(xd,64);
	FileSign ssig;
	FileSign bsig;
	FileSign fsig;

	bzero(&fsig,sizeof(fsig)); fsig.s_off = -1;
	bzero(&bsig,sizeof(fsig)); fsig.s_off = -1;
	bzero(&ssig,sizeof(ssig)); ssig.s_off = -1;
	md5 = newMD5();

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( streq(a1,"-vv") ){
			fverb = 1;
		}else
		if( streq(a1,"-w") ){
			fovw = 1;
		}else
		if( streq(a1,"-o") ){
			if( ai+1 < ac ){
				a1 = av[++ai];
				if( streq(a1,"-") )
					ofp = stdout;
				else{
					ofp = fopen(a1,"r+");
					if( ofp == NULL ){
						ofp = fopen(a1,"w");
					}
					if( ofp == NULL ){
				fprintf(stderr,"Cannot open: %s\n",a1);
						break;
					}
				}
			}
		}else
		if( streq(a1,"-m") ){
		}else{
			if( iexe != 0 && ifp != NULL ){
			getsigns(iexe,fovw,fverb,ifp,ofp,&ssig,&bsig,&fsig,md5,AVStr(xd));
				bzero(&fsig,sizeof(fsig)); fsig.s_off = -1;
				bzero(&ssig,sizeof(ssig)); ssig.s_off = -1;
				md5 = newMD5();
			}

			iexe = a1;
			ifp = fopen(iexe,"r+");
			if( ifp == NULL ){
				ifp = fopen(iexe,"r");
			}
			if( ifp == NULL ){
				fprintf(stderr,"Cannot open: %s\n",iexe);
				return -1;
			}
		}
	}
	if( iexe == 0 && isatty(fileno(stdin)) ){
		strcpy(mypath,EXEC_PATH);
		FullpathOfExe(AVStr(mypath));
		iexe = mypath;
		ifp = fopen(iexe,"r");
		if( ifp == NULL ){
			fprintf(stderr,"Cannot open: %s\n",iexe);
			return -1;
		}
	}
	if( ofp == 0 && fovw ){
		if( iexe ){
			ofp = fopen(iexe,"r+");
		}
	}
	if( iexe == 0 ){
		iexe = "-stdin";
	}
	getsigns(iexe,fovw,fverb,ifp,ofp,&ssig,&bsig,&fsig,md5,AVStr(xd));

	if( md5 ){
		if( 0 <= fsig.s_off )
		if( fseek(ifp,fsig.s_off,0) == 0 )
		if( fgets(buf,sizeof(buf),ifp) ){
			CStr(ndate,32);
			CStr(nsign,512);
			CStr(id,512);
			CStr(newsig,1024);
			const char *signer = "Author@DeleGate.ORG";

			StrftimeLocal(AVStr(ndate),sizeof(ndate),
				"%Y%m%d%H%M%S%z",time(0),0);

			if( 0 <= scanFileSign(buf,&fsig) ){
				CStr(com,1024);
				FILE *pfp;
				sprintf(id,"%s:%s:%s:%s",fsig.s_ver,ndate,xd,
					signer);
				sprintf(com,"rsasign %s",id);
				strcpy(nsign,"-");
				if( pfp = popen(com,"r") ){
					refQStr(np,nsign);
					while( fgets(np,sizeof(nsign),pfp) ){
						np += strlen(np);
					}
					strsubst(AVStr(nsign),"\n","");
					pclose(pfp);
				}
				setVStrEnd(xd,16);
				sprintf(id,"%s:%s:%s:%s",fsig.s_ver,ndate,xd,
					signer);
				sprintf(newsig,"%s=%s:%s",fsig.s_name,id,nsign);
				bcopy(newsig,(char*)buf+1,strlen(newsig));
			}else
			if( dp = strchr(buf,':') ){
fprintf(stderr,"?? %s\n",buf);
				dp++;
				bcopy(ndate,(char*)dp,strlen(ndate));
				if( dp = strchr(dp,':') ){
					dp++;
					bcopy(xd,(char*)dp,strlen(xd));
				}
			}
			if( ofp ){
				fprintf(stderr,"%s\n",buf);
				if( fseek(ofp,fsig.s_off,0) == 0 ){
					fputs(buf,ofp);
					fflush(ofp);
				}
			}
		}
	}
	return 0;
}

char *fgetsE(PVStr(str),int siz,FILE *fp){
	int ch;
	refQStr(sp,str);
	const char *sx;

	sx = &str[siz-3];
	for( sp = str; sp < sx; ){
		ch = getc(fp);
		if( ch == EOF )
			break;
		if( ch=='`' || ch=='~' || ch=='$' || ch=='#' || ch=='?' ){
			setVStrPtrInc(sp,'`'); setVStrPtrInc(sp,ch);
		}else
		if( ch == 0x7F ){
			setVStrPtrInc(sp,'`'); setVStrPtrInc(sp,'d');
		}else
		if( 0x00 <= ch && ch < 0x20 && ch != '\n' && ch != '\t' ){
			setVStrPtrInc(sp,'`'); setVStrPtrInc(sp,ch+'@');
		}else
		if( 0x80 <= ch && ch < 0xA0 ){
			setVStrPtrInc(sp,'~'); setVStrPtrInc(sp,ch-0x80+'@');
		}else
		if( 0xA0 <= ch && ch < 0xC0 ){
			setVStrPtrInc(sp,'$'); setVStrPtrInc(sp,ch-0xA0+'@');
		}else
		if( 0xC0 <= ch && ch < 0xE0 ){
			setVStrPtrInc(sp,'#'); setVStrPtrInc(sp,ch-0xC0+'@');
		}else
		if( 0xE0 <= ch ){
			setVStrPtrInc(sp,'?'); setVStrPtrInc(sp,ch-0xE0+'@');
		}else{
			setVStrPtrInc(sp,ch);
			if( ch == '\n' )
				break;
		}
	}
	setVStrEnd(sp,0);
	if( sp == str && feof(fp) )
		return NULL;
	return (char*)str;
}
int fputsEX(PCStr(str),FILE *fp,FILE *in){
	int ch;
	int nch;
	const char *sp;

	for( sp = str; ch = *sp; sp++ ){
		nch = sp[1];
		if( ch=='`' ){
			switch( nch ){
				case '`':
				case '~': case '$': case '#': case '?':
					putc(nch,fp); sp++;
					continue;
				case 'd':
					putc(0x7F,fp); sp++;
					continue;
				case '\n':
					sp++;
					continue;
			}
		}
		if( ch=='`'  || ch=='~' || ch=='$' || ch=='#' || ch=='?' ){
			if( nch == 0 ){
				if( in != NULL ){
					ungetc(ch,in);
				}else{
					fprintf(stderr,"--- fputSX ` %X\n",in);
				}
				break;
			}
			if( nch < '@' || '_' < nch ){
				fprintf(stderr,"--- fputSX unknonw ^%X\n",nch);
			}
			switch( ch ){
				case '`': putc(nch-'@',fp); sp++; break;
				case '~': putc(nch-'@'+0x80,fp); sp++; break;
				case '$': putc(nch-'@'+0xA0,fp); sp++; break;
				case '#': putc(nch-'@'+0xC0,fp); sp++; break;
				case '?': putc(nch-'@'+0xE0,fp); sp++; break;
			}
		}else{
			putc(ch,fp);
		}
	}
	return 0;
}
int fputsE(PCStr(str),FILE *fp){
	return fputsEX(str,fp,NULL);
}
int trx_main(int ac,const char *av[]){
	const char *a1;
	int ai;
	int fdec = 0;
	FILE *in = stdin;
	FILE *out = stdout;
	CStr(buf,8*1024);

	for( ai = 1; ai < ac; ai++ ){
		a1 = av[ai];
		if( streq(a1,"-d") ){
			fdec = 1;
		}
	}
	for(;;){
		if( fdec ){
			if( fgets(buf,sizeof(buf),in) == NULL )
				break;
			fputsEX(buf,out,in);
		}else{
			if( fgetsE(AVStr(buf),sizeof(buf),in) == NULL )
				break;
			fputs(buf,out);
		}
	}
	if( !fdec ){
		fputs("`\n",out);
	}
	return 0;
}
